package oose.class_diagram;

import java.util.ArrayList;
import java.util.Collection;


public class ComputerSystem extends PackagedProducts {
	private String brand;
	
	private Collection<Product> input;
	private Collection<Product> memory;
	private Collection<Product> hardDisks;
	
	private Platform platform;
	private CaseAndPower caseAndPower;
	private Multimedia multimediaAddons;
	
	public ComputerSystem(String brand, Collection<Product> memoryBanks, Collection<Product> hardDisks, Collection<Product> input) {
		if (memoryBanks.size() < 1) throw new RuntimeException("Must contain at least one memory bank.");
		if (memoryBanks.size() > 8) throw new RuntimeException("Must contain at most eight memory banks.");
		this.memory = new ArrayList<Product>(memoryBanks);
		super.addAll(this.memory);
		
		if (memoryBanks.size() < 1) throw new RuntimeException("Must contain at least one harddisk.");
		this.hardDisks = new ArrayList<Product>(hardDisks);
		super.addAll(this.hardDisks);

		this.input = new ArrayList<Product>(hardDisks);
		super.addAll(this.input);
		
		this.brand = brand;
	}

	public Platform getPlatform() {
		return platform;
	}
	public void setPlatform(Platform platform) {
		this.platform = platform;
	}
	
	public CaseAndPower getCaseAndPower() {
		return caseAndPower;
	}
	public void setCaseAndPower(CaseAndPower caseAndPower) {
		this.caseAndPower = caseAndPower;
	}
	
	public void setMultimediaAddons(Multimedia multimediaAddons) {
		this.multimediaAddons = multimediaAddons;
	}	
	public Multimedia getMultimediaAddons() {
		return multimediaAddons;
	}
	
	@Override
	public String specs() {
		return brand+" computer system.\n"+super.specs()+platform.specs()+caseAndPower.specs()+multimediaAddons.specs();
	}
	
	@Override
	public float price() {
		return super.price()+platform.price()+multimediaAddons.price()+caseAndPower.price();
	}
}
